require 'action_mailer'
class MailReader < ActionMailer::Base

  def mailtext(email)
    if email.multipart?
	email.parts.collect {|part|
	    if part.multipart? then
		mailtext(part)
	    else
		part.body if part.content_type == "text/plain"
	    end
	}.join
    end
  end
  def mailbody(email)
      empty = Proc.new {}
      email.body('utf-8',&empty).
    	    gsub(/<(script|style)[^>]*>.*<\/\1>/im, '').
            gsub(/<!--.*-->/m, '').
            gsub(/<hr(| [^>]*)>/i, "___\n").
            gsub(/<li(| [^>]*)>/i, "\n* ").
            gsub(/<blockquote(| [^>]*)>/i, '> ').
            gsub(/<(br)(| [^>]*)>/i, "\n").
            gsub(/<(\/h[\d]+|p)(| [^>]*)>/i, "\n\n").
            gsub(/<[^>]*>/, '').	
	    lstrip.gsub(/\n[ ]+/, "\n").gsub(/\n{3,}/,"\n\n") + "\n"                                                  
  end
  def receive(email)         
    author = User.find_by_mail @@sender
    if author.nil?
	puts @@sender + " not found"
	return false       
    end
    body = mailtext email 
    body = mailbody email if body.nil? or body.empty?
    subject = email.subject.sub(/^Fwd:\s+/,'');
    numbers = subject.match(/\s*\#(\d+)\s*/)
    issue = Issue.find_by_id_and_project_id(numbers[1],@@project_id) if !numbers.nil?
    category_id = nil
     subject.scan(/\[([^\]]*)\]/).each do |m|                                                                                                                                         
        name = m[0]                                                                                                                                                                 
        to = IssueCategory.find_by_name(name)                                                                                                                                        
        if !to.nil? then                                                                                                                                                            
	    category_id = to.id
            subject.gsub!('[' + name + ']','')
        end                                                                                                                                                                 
     end   
    if issue.nil? then
	issue = Issue.create(    
    	    :subject => subject.strip,
    	    :description => body.strip,
    	    :priority_id => 4,
    	    :project_id => @@project_id,
    	    :tracker_id => 3,
    	    :author_id => author.id,
    	    :status_id => 1,
	    :category_id => category_id
	) 
        puts "created issue #{issue.id}"
    else
	Journal.create(
	    :journalized_id => issue.id, 
	    :journalized_type => "Issue", 
	    :user_id => author.id, 
	    :notes => body
	)
	puts "created note to issue #{issue.id}"
    end	
    if email.has_attachments?
        for attachment in email.attachments        
	    attachment.original_filename = TMail::Unquoter.unquote_and_convert_to(attachment.original_filename, 'utf-8')
            Attachment.create(:container => issue, 
                              :file => attachment,
                              :description => "",
                              :author_id => author.id)
        end
    end
    issue
  end
  
  def self.check_mailbox  
     imap = imap_login
     Project.find(:all, :include=>:enabled_modules, :conditions=>"enabled_modules.name = 'mail_reader'").each do |project|
	@@project_id = project.id
    	begin    	
	    imap.select(project.identifier)
    	    imap.search(['ALL']).each do |message_id|
		msg = imap.fetch(message_id,'RFC822')[0].attr['RFC822']
        	@@sender = sender(imap, message_id)
   		imap.store(message_id, "+FLAGS", [:Deleted]) if MailReader.receive(msg)
    	    end
            imap.expunge()
	rescue
    	end                                                                                                              
     end
  end
  def self.create_project_folders
    imap = imap_login
    Project.find(:all).each do |project|
	begin
	    imap.select(project.identifier)
	rescue
	    imap.create(project.identifier)
	end  
    end
  end  
  def self.sender(imap, msg_id) 
    env = imap.fetch(msg_id, "ENVELOPE")[0].attr["ENVELOPE"]
    if !env.sender.nil? then
	emails = env.sender[0].name.match (/([a-z0-9_.-]+)@([a-z0-9-]+)\.([a-z.]+)/i) if !env.sender[0].name.nil?
	if !emails.nil? then
	    return emails[0]
	else	
	    mailbox = env.sender[0].mailbox
	    host    = env.sender[0].host

        end
    else
	mailbox = env.from[0].mailbox
	host    = env.from[0].host	
    end
    "#{mailbox}@#{host}"	    
  end

  def self.imap_login
     begin
       require 'net/imap'
     rescue LoadError
       raise RequiredLibraryNotFoundError.new('NET::Imap could not be loaded')
     end
     config_path = (RAILS_ROOT + '/config/mail_reader.yml')     
     config = YAML.load_file(config_path).symbolize_keys
     imap = Net::IMAP.new(config[:email_server], port=config[:email_port], usessl=config[:use_ssl])
     imap.login(config[:email_login], config[:email_password])
     imap
  end
end
